//-----------------------------------------
// LScript Generic template
//

@version 2.2
@warnings
@script generic
@name Make Muscle Bone

// global values go here
myversion=1.1;
myset;
mytgt=1;
myxon=2;
myyon=3;
myzon=4;
myxsc=5;
myysc=6;
myzsc=7;
myzof=8;

generic
{
//debug();    
    // perform all processing here
	myset[mytgt]=nil;
	myset[myxon]=true;
	myset[myyon]=true;
	myset[myzon]=true;
	myset[myxsc]=1.5;
	myset[myysc]=1.5;
	myset[myzsc]=1.0;
	myset[myzof]=1.5;

    myselected=Scene().getSelect();

    if (myselected.size()<2 or !(myselected[1].isBone() and myselected[2].isBone()))
    {
        error("Please select the bone to be a muscle and then its driving bone");
    }

    mymuscle=myselected[2];
    mycontrol=myselected[1];
    SelectItem(mymuscle.id);

    i=1;
    while(mymuscle.server("ItemMotionHandler",i))
    {
        if (mymuscle.server("ItemMotionHandler",i)=="MGMuscleBoneIA")
            error("Item is already a muscle");
        i++;
    }

//set up target bone
//debug();
    AddChildBone (mymuscle.name+"_MUSCLETGT");
    BoneRestLength (mymuscle.restlength/10);
    BoneRestPosition(0,0,mymuscle.restlength*1.5);
    Position(0,0,mymuscle.restlength*1.5);
    RefreshNow();
    myselected=Scene().getSelect();
    mytarget=myselected[1];
    if(Scene().generalopts[3]==true)
        ParentItem(mycontrol.id);
    else
    {
        ParentInPlace();
        ParentItem(mycontrol.id);
        ParentInPlace();
    }
    CreateKey(0);
    if (Scene().currenttime!=0)
        DeleteKey(Scene().currenttime);    
//    ItemLock(mytarget.id);
//    ItemVisibility(1);

    SelectItem(mymuscle.id);
    ApplyServer ("ItemMotionHandler", "MGMuscleBoneIA");

// Create a channel called MGMuscleBone, with an event callback called hello. 
// the procedure hello is called everytime an event appears on the comring on our channel.

    comringattach("MGMakeMuscleBone","hello");              
    myset[mytgt]=mytarget.id;
    mymuscleid=mymuscle.id;
	a[1]=myset[1];	a[2]=myset[2];	a[3]=myset[3];	a[4]=myset[4];
	b[1]=myset[5];	b[2]=myset[6];	b[3]=myset[7];	b[4]=myset[8];
// encode our tatget's item id so it can be put on the comring. It is an integer, so we
// use an array of one "i" element to indicate this. If there was more, we would use the form
// @"i","s:200#3","f#5","d"@ This would mean an integer, followed by 3 strings, which use a 200 byte
// buffer each (necessary for strings) 5 floats, and one double value. Note, the different types have 
// to be split into different arrays for encoding

    mycode=comringencode(@"i#4","f#4"@,a,b);

// place the code on the comring, with the identifier code mymuscleid so the motion plugin knows which
// object I'm talking to. 

    comringmsg("MGMakeMuscleBone",mymuscleid,mycode);

// message has been sent, so we can shut down this plugin's connection to the comring.
//when all plugins detach, the channel will be closed. 

    comringdetach("MGMakeMuscleBone");

    SelectItem(mymuscle.id);
    TargetItem(mytarget.id);
    HController(2);
    PController(2);


    i=1;
    while(mymuscle.server("ItemMotionHandler",i))
    {
        if (mymuscle.server("ItemMotionHandler",i)=="MGMuscleBoneIA")
            EditServer("ItemMotionHandler",i);
        i++;
    }
    SelectItem(mytarget.id);

}

hello: eventcode,data
{
}










